Typescript React Splitter Component

This tutorial will show you the basics of how to get started with the jQWidgets Splitter React Component.

Prerequisites

Refer to Getting Started with React before you start with this help topic.

Structure


I. Imports:

import * as React from 'react';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';
import JqxSplitter, { ISplitterProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxsplitter';

II. Class:

class App extends React.PureComponent<{}, ISplitterProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxSplitter
width={this.state.width} height={"100%"} .....
/>
)
}
}

III. Render:

Events

The event names in React are constructed of the original event names starting with capital letter plus on upfront:

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

Every component also have a method getOptions which returns the value of the requested option.

Splitter API

API Reference of the jQWidgets Splitter React Component: Splitter API

Splitter Demos

Demos Reference of the jQwidgets Splitter React Component: Splitter Demos

jQWidgets
  • Facebook
  • Twitter
  • Demo
  • Download
  • Documentation
  • License and Pricing
  • Services
  • Forums
  • About
  • Terms of Use
  • Privacy Policy
  • Contact Us

jQWidgets © 2011-2025. All Rights Reserved.

Angular Splitter Component

The Splitter component for Angular represents a moveable split bar(s) that divides a container's display area into two or more resizable and collapsible panels.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxSplitter [theme]="'fluent'" [width]="getWidth()" [height]="600"
             [panels]="[{ size: 200, min: 100 }, { min: 200, size: 400 }]">
    <div>
        <jqxExpander [theme]="'fluent'" style="border: none;" #feedExpander
                     [width]="'100%'" [height]="'100%'"
                     [toggleMode]="'none'" [showArrow]="false">
            <div class="jqx-hideborder">
                Feeds
            </div>
            <div class="jqx-hideborder jqx-hidescrollbars">
                <jqxTree [theme]="'fluent'" #treeReference (onSelect)="onTreeSelect($event)"
                         [width]="'100%'" [height]="'100%'">
                    <ul>
                        <li item-expanded="true" id="t1">
                            <img src="https://www.jqwidgets.com/angular/images/contactsIcon.png" /><span item-title="true">News and Blogs</span>
                            <ul>
                                <li>
                                    <img src="https://www.jqwidgets.com/angular/images/favorites.png" /><span item-title="true">Favorites</span>
                                    <ul>
                                        <li>
                                            <img src="https://www.jqwidgets.com/angular/images/folder.png" /><span item-title="true">ScienceDaily</span>
                                        </li>
                                    </ul>
                                </li>
                                <li>
                                    <img src="https://www.jqwidgets.com/angular/images/folder.png" /><span item-title="true">Geek.com</span>
                                </li>
                                <li>
                                    <img src="https://www.jqwidgets.com/angular/images/folder.png" /><span item-title="true">CNN.com</span>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </jqxTree>
            </div>
        </jqxExpander>
    </div>
  <div>
    <jqxSplitter [theme]="'fluent'" #horizontalSplitter [width]="'100%'" [height]="'100%'" [orientation]="'horizontal'"
                 [panels]="[{ size: 400, min: 100, collapsible: false },{ min: 100, collapsible: true }]">
      <div class="feed-item-list-container" id="feedUpperPanel">
        <jqxExpander [theme]="'fluent'" class="jqx-hideborder" #feedListExpander
                     [width]="'100%'" [height]="'100%'"
                     [toggleMode]="'none'" [showArrow]="false">
          <div class="jqx-hideborder" id="feedHeader">
          </div>
          <div class="jqx-hideborder jqx-hidescrollbars">
            <jqxListBox [theme]="'fluent'" #listBoxReference class="jqx-hideborder" (onSelect)="onListBoxSelect($event)"
                        [width]="'100%'" [height]="'100%'" [source]="['1']">
            </jqxListBox>
          </div>
        </jqxExpander>
      </div>
      <div id="feedContentArea">
        <jqxExpander [theme]="'fluent'" class="jqx-hideborder" #feedContentExpander
                     [width]="'100%'" [height]="'100%'"
                     [toggleMode]="'none'" [showArrow]="false">
          <div class="jqx-hideborder" id="feedItemHeader">
          </div>
          <div class="jqx-hideborder jqx-hidescrollbars">
            <jqxPanel [theme]="'fluent'" #panelReference class="jqx-hideborder"
                      [width]="'100%'" [height]="'100%'">
              Select a news item to see it"s content
            </jqxPanel>
          </div>
        </jqxExpander>
      </div>
    </jqxSplitter>
  </div>
</jqxSplitter>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, AfterViewInit, ElementRef } from '@angular/core';

import { map } from 'rxjs/operators';
import {
  jqxExpanderModule,
  jqxExpanderComponent,
} from 'jqwidgets-ng/jqxexpander';

import { jqxPanelComponent, jqxPanelModule } from 'jqwidgets-ng/jqxpanel';
import { jqxListBoxModule, jqxListBoxComponent } from 'jqwidgets-ng/jqxlistbox';
import { jqxTreeModule, jqxTreeComponent } from 'jqwidgets-ng/jqxtree';

import {
  jqxSplitterModule,
  jqxSplitterComponent,
} from 'jqwidgets-ng/jqxsplitter';
@Component({
  selector: 'app-root',
  imports: [
    jqxSplitterModule,
    jqxTreeModule,
    jqxListBoxModule,
    jqxPanelModule,
    jqxExpanderModule,
  ],
  standalone: true,
  templateUrl: './app.component.html',
})
export class AppComponent implements AfterViewInit {
  @ViewChild('feedContentExpander') feedContentExpander: jqxExpanderComponent;
  @ViewChild('feedListExpander') feedListExpander: jqxExpanderComponent;
  @ViewChild('listBoxReference') myListBox: jqxListBoxComponent;
  @ViewChild('panelReference') myPanel: jqxPanelComponent;
  @ViewChild('treeReference') myTree: jqxTreeComponent;
  getWidth(): any {
    if (document.body.offsetWidth < 850) {
      return '90%';
    }

    return 850;
  }
  constructor() {}
  ngAfterViewInit(): void {
    this.getFeed('sciencedaily');
  }

  onTreeSelect(event: any): void {
    let item = this.myTree.getItem(event.args.element);
    this.getFeed(this.config['feeds'][item.label]);
  }

  onListBoxSelect(event: any): void {
    this.loadContent(event.args.index);
  }

  selectFirst(): void {
    this.myListBox.selectIndex(0);
    this.loadContent(0);
  }

  getFeed(feed: any): void {
    this.config['currentFeed'] = feed;
    if (feed !== undefined) {
      feed = this.config['dataDir'] + '/' + feed + '.' + this.config['format'];
      this.loadFeed(feed);
    }
  }

  loadFeed(feed: any, callback?: any): void {}

  displayFeedHeader(header: string): void {
    this.feedListExpander.setHeaderContent(header);
  }

  displayFeedList(items: any): void {
    let headers = this.getHeaders(items);
    this.myListBox.source(headers);
  }

  getHeaders(items: any): any {
    let headers = [],
      header;
    for (let i = 0; i < items.length; i += 1) {
      header = items[i].title;
      headers.push(header);
    }
    return headers;
  }

  loadContent(index: number): void {
    let item = this.config['currentFeedContent'][index];
    if (item != null) {
      this.myPanel.clearcontent();
      this.myPanel.prepend(
        '<div style="padding: 1px;"><span>' + item.description + '</span></div>'
      );
      this.addContentHeaderData(item);
      this.config['selectedIndex'] = index;
    }
  }

  addContentHeaderData(item: any): void {
    let link = document.createElement('a');
    link.style.whiteSpace = 'nowrap';
    link.style.marginLeft = '15px';
    link.target = '_blank';
    let text = document.createTextNode('Source');
    link.appendChild(text);
    let date = document.createElement('div');
    date.style.whiteSpace = 'nowrap';
    date.style.marginLeft = '30px';
    date.appendChild(document.createTextNode(item.pubDate));
    let container = <HTMLElement>document.createElement('table');
    container.style.height = '100%';
    let element1 = <HTMLElement>document.createElement('tr');
    container.appendChild(element1);
    container.appendChild(document.createElement('td'));
    container.appendChild(document.createElement('td'));
    link.href = item.link;
    (<HTMLElement>document.getElementById('feedItemHeader')).innerHTML = null;
    (<HTMLElement>document.getElementById('feedItemHeader')).appendChild(
      container
    );
    container.getElementsByTagName('td')[0].appendChild(link);
    container.querySelector('td:last-child').appendChild(date);
    this.feedContentExpander.setHeaderContent(container.outerHTML);
  }

  config: any = {
    feeds: {
      'CNN.com': 'cnn',
      'Geek.com': 'geek',
      ScienceDaily: 'sciencedaily',
    },
    format: 'txt',
    dataDir: '../assets',
    feedTree: <HTMLElement>document.getElementsByTagName('angularTree')[0],
    feedItemHeader: <HTMLElement>document.getElementById('feedItemHeader'),
    feedUpperPanel: <HTMLElement>document.getElementById('feedUpperPanel'),
    feedHeader: <HTMLElement>document.getElementById('feedHeader'),
    feedContentArea: <HTMLElement>document.getElementById('feedContentArea'),
    selectedIndex: -1,
    currentFeed: '',
    currentFeedContent: {},
  };
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Splitter API

API Reference of the jQWidgets Splitter component for Angular: Splitter API

Vue UI Components Documentation

Vue Splitter Component

The Splitter component for Vue represents a moveable split bar(s) that divides a container's display area into two or more resizable and collapsible panels.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Splitter component for Vue requires the following import:

import JqxSplitter from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxsplitter.vue';

Add the jqxSplitter component to the components section of the the Vue class:

 components: {
JqxSplitter
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxSplitter/>

<template>
<JqxSplitter :height="height" :width="width"
:panels="panels">
<div>Panel One</div>
<div>Panel Two</div>
</JqxSplitter>
</template>

Properties

The properties of the <JqxSplitter/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
width: 800,
height: 500,
panels: [{ size: '50%', min: '10%', collapsible: false }, { size: '50%', min: '5%' }]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxSplitter @resize="onResize()"
:height="height" :width="width"
:panels="panels">
<div>Panel One</div>
<div>Panel Two</div>
</JqxSplitter>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onResize: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxSplitter ref="splitter"></JqxSplitter>

Here how you can use a component's method:

this.$refs.splitter.refresh();

methods: {
// Add here all used callbacks and/or events
onResize: function () {
// Do something...
this.refs.splitter.refresh();
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxSplitter ref="splitter" @resize="onResize()"
:height="height" :width="width"
:panels="panels">
<div>Panel One</div>
<div>Panel Two</div>
</JqxSplitter>
</template>
<script>
// Import the components that will be used
import JqxSplitter from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxsplitter.vue';
export default {
components: {
// Adding imported widgets here
JqxSplitter
},
data: function () {
// Define properties which will use in the widget
return {
width: 800,
height: 500,
panels: [{ size: '50%', min: '10%', collapsible: false }, { size: '50%', min: '5%' }]
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onResize: function () {
// Do something...
this.refs.splitter.refresh();
}
}
}
</script>
<style>
</style>

Splitter Example

<template>
<JqxSplitter :width="850" :height="850" :orientation="'horizontal'"
:panels="[{ size: '50%' }, { size: '50%' }]">
<div>
<JqxSplitter class="jqx-splitter-nested"
:width="'100%'" :height="'100%'" :orientation="'vertical'"
:panels="[{ size: 300, collapsible: false }]">
<div>
<JqxSplitter class="jqx-splitter-nested"
:width="'100%'" :height="'100%'" :orientation="'horizontal'"
:panels="[{ size: 150 }]">
<div>
<span>Panel 1</span>
</div>
<div>
<span>Panel 2</span>
</div>
</JqxSplitter>
</div>
<div>
<span>Panel 3</span>
</div>
</JqxSplitter>
</div>
<div>
<JqxSplitter class="jqx-splitter-nested"
:width="'100%'" :height="'100%'" :orientation="'horizontal'"
:panels="[{ size: 150, collapsible: false }]">
<div>
<span>Panel 4</span>
</div>
<div>
<span>Panel 5</span>
</div>
</JqxSplitter>
</div>
</JqxSplitter>
</template>
<script>
import JqxSplitter from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxsplitter.vue';
export default {
components: {
JqxSplitter
}
}
</script>
<style>
.jqx-splitter-nested {
border: none !important;
}
</style>

Run Code